<div class="flex flex-col h-screen m-2">

  <mat-card class="m-4">
    <div class="ft-weight-900 f-24 fm-rauth">My Profile</div>
  </mat-card>

  <mat-accordion class="example-headers-align m-4 mt-0" multi>
    <mat-expansion-panel [expanded]="isExpanded[0]">
      <mat-expansion-panel-header (click)="$event.stopPropagation()" [ngClass]="!isExpanded[0] ? 'border-bottom' : ''">
        <mat-panel-title (click)="$event.stopPropagation()">
          <div class="flex justify-between w-100">
          <div class="flex items-center">
              <button class="secondary-icon mr-3" (click)="togglePanel($event,0)">
                <mat-icon *ngIf="isExpanded[0]">
                    keyboard_arrow_up
                </mat-icon>
                <mat-icon *ngIf="!isExpanded[0]">
                  keyboard_arrow_down
              </mat-icon>
              </button>
            <div>
              <div class="ft-weight-900 f-16 fm-rauth">
                Personal Details
              </div>
              <div>
                <span class="ft-weight-500 f-14 fm-rauth-light">Full name</span>: <span class="ft-weight-500 f-14 fm-rauth">{{personalForm.controls.fullName.value}}</span>
              </div>
            </div>
          </div>
          <div>
            <mat-chip-set>
              <mat-chip *ngFor="let role of roles">
                {{ role }}
              </mat-chip>
            </mat-chip-set>
          </div>
          </div>
        </mat-panel-title>
      </mat-expansion-panel-header>
      
      <form class="sm:w-full p-2" [formGroup]="personalForm" method="post">
        <input hidden formControlName="picture" (change)="onFileChanged()" #fileInput type="file" accept="image/*">
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>Full Name</mat-label>
          <input matInput formControlName="fullName" placeholder="">
        </mat-form-field>
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>Email</mat-label>
          <input matInput formControlName="email" readonly>
          <button mat-button matSuffix *ngIf="personalForm.controls.email.value && !(isEmailVerified | async)"
            [disabled]="isVerifyEmailDisabled" (click)="emailVerificationCode()">
            <mat-icon>warning</mat-icon>
          </button>
        </mat-form-field>
        <mat-form-field *ngIf="phone" class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>Phone</mat-label>
          <input matInput formControlName="phone" readonly>
        </mat-form-field>
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>First Name</mat-label>
          <input matInput formControlName="givenName" placeholder="">
        </mat-form-field>
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>Middle Name</mat-label>
          <input matInput formControlName="middleName" placeholder="">
        </mat-form-field>
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>Last Name</mat-label>
          <input matInput formControlName="familyName" placeholder="">
        </mat-form-field>
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>Nickname</mat-label>
          <input matInput formControlName="nickname" placeholder="">
        </mat-form-field>
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>Gender</mat-label>
          <mat-select formControlName="gender" placeholder="">
            <mat-option *ngFor="let g of genders" [value]="g">
              {{ g }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>Website</mat-label>
          <input matInput formControlName="website" placeholder="">
        </mat-form-field>
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>Time Zone</mat-label>
          <mat-select formControlName="zoneinfo" placeholder="">
            <mat-option *ngFor="let timezone of timezones" [value]="timezone.abbr">
              {{ timezone.text }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-label>Locale</mat-label>
          <mat-select formControlName="locale" placeholder="">
            <mat-option *ngFor="let l of locales" [value]="l.code">
              {{ l.name }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <mat-form-field class="md:w-1/2 md:pl-1 sm:w-full">
          <mat-datepicker-toggle matSuffix [for]="birthdatePicker"></mat-datepicker-toggle>
          <mat-label>Birthdate</mat-label>
          <input matInput formControlName="birthdate" [matDatepicker]="birthdatePicker" placeholder=""
            [value]="birthdate" (dateInput)="updateBirthdate('input', $event)">
          <mat-datepicker #birthdatePicker disabled="false"></mat-datepicker>
        </mat-form-field>
      </form>

      <button (click)="updateOpenIDClaims()" mat-button color="primary" [disabled]="!personalForm.valid" class="secondary mr-3">Update</button>
      <button (click)="updatePhone()" *ngIf="enableUserPhone" mat-button class="secondary mr-3">Update Phone</button>
      <button (click)="updateEmail()" mat-button class="secondary mr-3">Update Email</button>
      <button *ngIf="hideAvatar" mat-button (click)="fileInput.click()" class="secondary mr-3">Choose Avatar</button>
      <button *ngIf="hideAvatar && picture !== missingAvatarImage" mat-button color="warn"
        (click)="deleteAvatar()" class="secondary mr-3">Delete Avatar</button>

    </mat-expansion-panel>

    <mat-expansion-panel [expanded]="isExpanded[1]">
      <mat-expansion-panel-header (click)="$event.stopPropagation()" [ngClass]="!isExpanded[1] ? 'border-bottom' : ''">
        <mat-panel-title (click)="$event.stopPropagation()">
          <div class="flex justify-between w-100">
          <div class="flex items-center">
            <button class="secondary-icon mr-3" (click)="togglePanel($event,1)">
              <mat-icon *ngIf="isExpanded[1]">
                  keyboard_arrow_up
              </mat-icon>
              <mat-icon *ngIf="!isExpanded[1]">
                keyboard_arrow_down
            </mat-icon>
            </button>

            <div>
              <div class="ft-weight-900 f-16 fm-rauth">
                Password
              </div>
              <div>
                <span class="ft-weight-500 f-14 fm-rauth-light">Change or set your password</span>
              </div>
            </div>

        </div>
        
      </div>
          </mat-panel-title>
      </mat-expansion-panel-header>

      <div>
        <button *ngIf="!isPasswordSet" (click)="setPassword()" mat-button [disabled]="sentForgotPasswordEmail" color="primary" class="secondary mr-3">Set Password</button>
        <button *ngIf="!showPasswordSection" (click)="showChangePassword()" mat-button color="primary"  class="secondary">Change
          Password</button>
      </div>

      <form class="md:w-1/2 sm:w-full p-2" *ngIf="showPasswordSection" [formGroup]="changePasswordForm" method="post">
        <mat-form-field class="w-full p-1">
          <mat-label>Current Password</mat-label>
          <input matInput type="password" formControlName="currentPassword" required>
        </mat-form-field>
        <mat-form-field class="w-full p-1">
          <mat-label>New Password</mat-label>
          <input matInput type="password" formControlName="newPassword" required>
        </mat-form-field>
        <mat-form-field class="w-full p-1">
          <mat-label>Repeat Password</mat-label>
          <input matInput type="password" formControlName="repeatPassword" required>
        </mat-form-field>
        <app-password-requirement></app-password-requirement>
      </form>      

      <button (click)="changePasswordRequest()" mat-button color="primary" *ngIf="showPasswordSection" [disabled]="changePasswordForm.invalid" class="secondary">Update</button>
    </mat-expansion-panel>

    <mat-expansion-panel [expanded]="isExpanded[2]">
      <mat-expansion-panel-header (click)="$event.stopPropagation()" [ngClass]="!isExpanded[2] ? 'border-bottom' : ''">
        <mat-panel-title (click)="$event.stopPropagation()">
          <div class="flex items-center">
            <button class="secondary-icon mr-3" (click)="togglePanel($event,2)">
              <mat-icon *ngIf="isExpanded[2]">
                  keyboard_arrow_up
              </mat-icon>
              <mat-icon *ngIf="!isExpanded[2]">
                keyboard_arrow_down
            </mat-icon>
            </button>
            <div>
              <div class="ft-weight-900 f-16 fm-rauth">
                Security Details
              </div>
              <div>
                <span class="ft-weight-500 f-14 fm-rauth-light">Multi Factor Authentication</span>
              </div>
              </div>
        </div>
          </mat-panel-title>
      </mat-expansion-panel-header>
      <div>
      <mat-slide-toggle [checked]="checked2fa" (click)="enableDisable2fa()" class="mb-3">
        {{ checked2fa ? 'Enabled' : 'Disabled' }}
      </mat-slide-toggle>
      <div>
      <button (click)="manageKeys()" mat-button color="primary" class="secondary mr-3">Manage Keys</button>
      <button *ngIf="!enablePasswordLess" (click)="enablePasswordLessLogin()" mat-button class="secondary mr-3">Enable Password-less</button>
      <button *ngIf="enablePasswordLess" (click)="disablePasswordLess()" mat-button class="secondary mr-3">Disable Password-less</button>
      <button *ngIf="!checkIfAdmin() && !enableOTP" mat-button (click)="enableProfileOTP()" class="secondary mr-3">Enable OTP</button>
      <button *ngIf="!checkIfAdmin() && enableOTP" mat-button (click)="disableProfileOTP()" class="secondary mr-3">Disable OTP</button>
    </div>
  </div>
    </mat-expansion-panel>

    <mat-expansion-panel [expanded]="isExpanded[3]">
      <mat-expansion-panel-header (click)="$event.stopPropagation()" [ngClass]="!isExpanded[3] ? 'border-bottom' : ''">
        <mat-panel-title (click)="$event.stopPropagation()">
          <div class="flex items-center">
            <button class="secondary-icon mr-3" (click)="togglePanel($event,3)">
              <mat-icon *ngIf="isExpanded[3]">
                  keyboard_arrow_up
              </mat-icon>
              <mat-icon *ngIf="!isExpanded[3]">
                keyboard_arrow_down
            </mat-icon>
            </button>
            <div>
              <div class="ft-weight-900 f-16 fm-rauth">
                Connected Apps
              </div>
              <div>
                <span class="ft-weight-500 f-14 fm-rauth-light">View External Applications</span>
              </div>
              </div>
        </div>
          </mat-panel-title>
      </mat-expansion-panel-header>
      <div class="flex flex-col align-center gap-2 ml-10 mt-2">
        <div *ngIf="apps.length === 0" class="text-center ft-weight-200 fm-rauth-light f-16">No Connected Apps Found</div>
        <div *ngFor="let app of apps" class="flex flex-row items-center gap-20">
          <div class="flex flex-col align-center">
            <div class="ft-weight-300">
              {{app.clientName}}
            </div>
            <div class="ft-weight-200 fm-rauth-light f-12">
              First Login: {{app.creation | date: "medium"}}
            </div>
          </div>
          <div>
            <button (click)="revokeExternalAppToken(app.clientId)" mat-button color="warn" class="f-14">Revoke</button>
          </div>
        </div>
      <div>
    </div>
  </div>
  </mat-expansion-panel>
    <mat-expansion-panel [expanded]="isExpanded[4]">
      <mat-expansion-panel-header (click)="$event.stopPropagation()">
        <mat-panel-title (click)="$event.stopPropagation()">
          <div class="flex items-center">
            <button class="secondary-icon mr-3" (click)="togglePanel($event,4)">
              <mat-icon *ngIf="isExpanded[4]">
                  keyboard_arrow_up
              </mat-icon>
              <mat-icon *ngIf="!isExpanded[4]">
                keyboard_arrow_down
            </mat-icon>
            </button>
            <div>
              <div class="ft-weight-900 f-16 fm-rauth">
                Delete User
              </div>
              <div>
                <span class="ft-weight-500 f-14 fm-rauth-light" *ngIf="checkIfAdmin()">
                  Administrator cannot be deleted
                </span>
                <span class="ft-weight-500 f-14 fm-rauth-light" *ngIf="!checkIfAdmin()">
                  Deleting User Account is irreversible
                </span>
              </div>
              </div>
        </div>
          </mat-panel-title>
      </mat-expansion-panel-header>
      <button [disabled]="checkIfAdmin()" (click)="deleteUser()" mat-button color="warn" class="secondary warning">Delete User</button>
      </mat-expansion-panel>

    </mat-accordion>
 </div>




